/*requires Schema.Reporting.sql*/


PRINT '--------------------------------------------------------------------------------------------------------------'
PRINT 'Table [Reporting].[ExecutionLog] Creation'

IF  NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[Reporting].[ExecutionLog]') AND type in (N'U'))
BEGIN
    CREATE TABLE [Reporting].[ExecutionLog] (
        [ReportId]              BIGINT        NOT NULL IDENTITY(1,1),
        [ReportClass]           VARCHAR(512)  NULL,
        [ReportName]            VARCHAR(512)  NOT NULL,
        [SQLLogin]              VARCHAR(512)  NOT NULL,
        [ClientNetAddress]      VARCHAR(128)  NOT NULL,
        [ClientHostName]        VARCHAR(128)  NOT NULL,
        [ClientProgramName]     VARCHAR(256)  NOT NULL,
        [StartTime]             DATETIME      NOT NULL,
        [EndTime]               DATETIME      NULL,
        [OutputType]            VARCHAR(32)   NULL, -- TABLE / FILE / NONE
        [OutputPath]            VARCHAR(MAX)  NULL,
        [ReportParams]          VARCHAR(MAX)  NULL,
        [Outcome]               VARCHAR(64)   NULL,
        [ErrorDetails]          VARCHAR(MAX)  NULL
    )
    ON [PRIMARY]

    IF @@ERROR = 0
        PRINT '   Table created.'
    ELSE
    BEGIN
        PRINT '   Error while trying to create table.'
        RETURN
    END
END
GO

IF  NOT EXISTS (SELECT 1 FROM sys.indexes WHERE object_id = OBJECT_ID(N'[Reporting].[ExecutionLog]') AND name = N'PK_ExecutionLog')
BEGIN 
    ALTER TABLE [Reporting].[ExecutionLog] ADD  CONSTRAINT [PK_ExecutionLog] PRIMARY KEY NONCLUSTERED (
       ReportId
    );
    
    PRINT '    Primary Key created.';
    
END;
GO



PRINT '--------------------------------------------------------------------------------------------------------------'
PRINT ''
